#ifndef _ODAI_CLIENT_H_
#define _ODAI_CLIENT_H_

#include <odai/functions.h>
#include <odai/signal.h>
#include <odai/mutex.h>
#include <odai/snl.h>

class Client {

public:
	Client(const char *host, unsigned short port);
	~Client();

	int reg(const char *fmt, void *fn);
	int fnc(const char *fmt, ...);
	int fnc(int *ret,    const char *fmt, ...);
	int fnc(double *ret, const char *fmt, ...);
	int fnc(char **ret,  const char *fmt, ...);
	int err(void (*fn)(int err));

private:

	int server;

	void (*error_handler)(int err);

	static SNL_READ_CALLBACK(read_callback);

	int    ret_i;
	double ret_f;
	string ret_s;

	Signal    rcvd;
	Mutex     mutex;
	Functions messages;

	int call(char type, void *ptr, const char *fmt, va_list args); 

};

#endif
