#ifndef _FUNCTIONS_H_
#define _FUNCTIONS_H_

#define HASH_MAP

#ifdef HASH_MAP
	#include <hash_map>
#else
	#include <map>
#endif

#include <vector>
#include <string>

class Functions {

public:

	~Functions();

	bool reg(const char *fmt, void *fn);
	bool call(int fd, void *buf, int len, bool answer=true);

private:

	class Function {

	public:

		string ret;
		string fnc;
		string par;
		void   *fn;

	};

	vector<Function *> functions;

#ifdef HASH_MAP
	struct cmpstr {
		bool operator()(const char* s1, const char* s2) const {
			return (strcmp(s1, s2) == 0);
		}
	};
	hash_map<const char *, Function *, hash<const char *>, cmpstr> func;
	#undef HASH_MAP
#else
	map<const char *, Function *> func;
#endif

};

#endif
