#ifndef _PACKET_H_
#define _PACKET_H_

#include <string>
#include <vector>

#include <stdarg.h>

class Packet {

public:

	char type();
	void type(char type);

	void push(int i);
	void push(char *s);
	void push(string s);
	void push(double f);
	void push(vector<int> v);
	void push(vector<string> v);
	void push(vector<double> v);

	void pop(int &i);
	void pop(string &s);
	void pop(double &f);
	void pop(vector<int> &v);
	void pop(vector<string> &v);
	void pop(vector<double> &v);

	void rewind();
	void reset();
	void assign(void *b, int s);

	bool build(void *b, int s);
	bool build(const char *fmt, va_list args);

	char *data();
	int  size();

	Packet();

private:

	void append(const char *s);

	string buf;
	int    pos;

};

#endif
